#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <math.h>

#define PRIME 0
#define NOT_PRIME 1

void * make_sieve(int* numbers)
{
	char * sieve = calloc(*numbers, sizeof(char));
	int test_max = sqrt(*numbers) + 1;
	//From the definition of prime numbers:
	sieve[0] = sieve[1] = NOT_PRIME;
	//Create the sieve
	for(int i=2 ; i<test_max ; i++)
	{
		//If the current number is prime, try dividing all 
		//subsequent potential primes by it
		if(sieve[i] == PRIME)
		{
			//Any number which is a product of prime number
			//is not prime itself
			for(int j=i+i ; j<*numbers ; j+=i)
			{
				sieve[j] = NOT_PRIME;
			}
		}
	}
	return sieve;
}

int main(void)
{
	pthread_t thread;
	int max = 20000;
	int test_number;
	char* sieve;
	//Spawn a thread to create the sieve
	pthread_create(&thread, NULL, (void*(*)(void*))make_sieve, (void*)&max);
	printf("Enter a number: ");
	scanf("%d", &test_number);
	//Collect the sieve
	pthread_join(thread, (void**)&sieve);
	//Check the entered number is in range
	if(test_number >= max)
	{
		test_number = max-1;
	}
	if(sieve[test_number] == PRIME)
	{
		printf("\n%d is prime.\n", test_number);
	}
	else
	{
		printf("\n%d is not prime.\n", test_number);
	}
	return 0;
}
